#ifndef __GILUT_H__
#define __GILUT_H__

// GLUT initialization sub-API
#define gilutInit(argcp, argv) glutInit(argcp, argv)
#define gilutInitDisplayMode(mode) glutInitDisplayMode(mode)
#define gilutInitWindowPosition(x, y) glutInitWindowPosition(x, y)
#define gilutInitWindowSize(width, height) glutInitWindowSize(width, height)
#define gilutMainLoop() glutMainLoop()

// GLUT window sub-api
#define gilutCreateWindow(title) glutCreateWindow(title)
#define gilutCreateSubWindow(win, x, y, width, height) glutCreateSubWindow(win, x, y, width, height)
#define gilutDestroyWindow(win) glutDestroyWindow(win)
#define gilutPostRedisplay() glutPostRedisplay()
#define gilutSwapBuffers() glutSwapBuffers()
#define gilutGetWindow() glutGetWindow()
#define gilutSetWindow(win) glutSetWindow(win)
#define gilutSetWindowTitle(title) glutSetWindowTitle(title)
#define gilutSetIconTitle(title) glutSetIconTitle(title)
#define gilutPositionWindow(x, y) glutPositionWindow(x, y)
#define gilutReshapeWindow(width, height) glutReshapeWindow(width, height)
#define gilutPopWindow() glutPopWindow()
#define gilutPushWindow() glutPushWindow()
#define gilutIconifyWindow() glutIconifyWindow()
#define gilutShowWindow() glutShowWindow()
#define gilutHideWindow() glutHideWindow()
#if (GLUT_API_VERSION >= 3)
#define gilutFullScreen() glutFullScreen()
#define gilutSetCursor(cursor) glutSetCursor(cursor)
#if (GLUT_API_VERSION >= 4)
#define gilutWarpPointer(x, y) glutWarpPointer(x, y)
#endif

// GLUT overlay sub-API
#define gilutEstablishOverlay() glutEstablishOverlay()
#define gilutRemoveOverlay() glutRemoveOverlay()
#define gilutUseLayer(layer) glutUseLayer(layer)
#define gilutPostOverlayRedisplay() glutPostOverlayRedisplay()
#define gilutShowOverlay() glutShowOverlay()
#define gilutHideOverlay() glutHideOverlay()
#endif

// GLUT menu sub-API
#define gilutCreateMenu(func_ptr) glutCreateMenu(func_ptr)
#define gilutDestroyMenu(menu) glutDestroyMenu(menu)
#define gilutGetMenu() glutGetMenu()
#define gilutSetMenu(menu) glutSetMenu(menu)
#define gilutAddMenuEntry(label, value) glutAddMenuEntry(label, value)
#define gilutAddSubMenu(label, submenu) glutAddSubMenu(label, submenu)
#define gilutChangeToMenuEntry(item, label, value) glutChangeToMenuEntry(item, label, value)
#define gilutChangeToSubMenu(item, label, submenu) glutChangeToSubMenu(item, label, submenu)
#define gilutRemoveMenuItem(item) glutRemoveMenuItem(item)
#define gilutAttachMenu(button) glutAttachMenu(button)
#define gilutDetachMenu(button) glutDetachMenu(button)

// GLUT callback sub-api
#define gilutDisplayFunc(func_ptr) glutDisplayFunc(func_ptr)
#define gilutReshapeFunc(func_ptr) glutReshapeFunc(func_ptr)
#define gilutKeyboardFunc(func_ptr) glutKeyboardFunc(func_ptr)
#define gilutMouseFunc(func_ptr) glutMouseFunc(func_ptr)
#define gilutMotionFunc(func_ptr) glutMotionFunc(func_ptr)
#define gilutPassiveMotionFunc(func_ptr) glutPassiveMotionFunc(func_ptr)
#define gilutEntryFunc(func_ptr) glutEntryFunc(func_ptr)
#define gilutVisibilityFunc(func_ptr) glutVisibilityFunc(func_ptr)
#define gilutIdleFunc(func_ptr) glutIdleFunc(func_ptr)
#define gilutTimerFunc(millis, func_ptr, value) glutTimerFunc(millis, func_ptr, value)
#define gilutMenuStateFunc(func_ptr) glutMenuStateFunc(func_ptr)
#if (GLUT_API_VERSION >= 2)
#define gilutSpecialFunc(func_ptr) glutSpecialFunc(func_ptr)
#define gilutSpaceballMotionFunc(func_ptr) glutSpaceballMotionFunc(func_ptr)
#define gilutSpaceballRotateFunc(func_ptr) glutSpaceballRotateFunc(func_ptr)
#define gilutSpaceballButtonFunc(func_ptr) glutSpaceballButtonFunc(func_ptr)
#define gilutButtonBoxFunc(func_ptr) glutButtonBoxFunc(func_ptr)
#define gilutDialsFunc(func_ptr) glutDialsFunc(func_ptr)
#define gilutTabletMotionFunc(func_ptr) glutTabletMotionFunc(func_ptr)
#define gilutTabletButtonFunc(func_ptr) glutTabletButtonFunc(func_ptr)
#if (GLUT_API_VERSION >= 3)
#define gilutMenuStatusFunc(func_ptr) glutMenuStatusFunc(func_ptr)
#define gilutOverlayDisplayFunc(func_ptr) glutOverlayDisplayFunc(func_ptr)
#endif
#endif

// GLUT color index sub-api
#define gilutSetColor(int, red, green, blue) glutSetColor(int, red, green, blue)
#define gilutGetColor(ndx, component) glutGetColor(ndx, component)
#define gilutCopyColormap(win) glutCopyColormap(win)

// GLUT state retrieval sub-api
#define gilutGet(type) glutGet(type)
#define gilutDeviceGet(type) glutDeviceGet(type)
#if (GLUT_API_VERSION >= 2)
// GLUT extension support sub-API
#define gilutExtensionSupported(name) glutExtensionSupported(name)
#endif
#if (GLUT_API_VERSION >= 3)
#define gilutGetModifiers() glutGetModifiers()
#define gilutLayerGet(type) glutLayerGet(type)
#endif

// GLUT font sub-API
#define gilutBitmapCharacter(font, character) glutBitmapCharacter(font, character)
#define gilutBitmapWidth(font, character) glutBitmapWidth(font, character)
#define gilutStrokeCharacter(font, character) glutStrokeCharacter(font, character)
#define gilutStrokeWidth(font, character) glutStrokeWidth(font, character)

// GLUT pre-built models sub-API
#define gilutWireSphere(radius, slices, stacks) glutWireSphere(radius, slices, stacks)
#define gilutSolidSphere(radius, slices, stacks) glutSolidSphere(radius, slices, stacks)
#define gilutWireCone(base, height, slices, stacks) glutWireCone(base, height, slices, stacks)
#define gilutSolidCone(base, height, slices, stacks) glutSolidCone(base, height, slices, stacks)
#define gilutWireCube(size) glutWireCube(size)
#define gilutSolidCube(size) glutSolidCube(size)
#define gilutWireTorus(innerRadius, outerRadius, sides, rings) glutWireTorus(innerRadius, outerRadius, sides, rings)
#define gilutSolidTorus(innerRadius, outerRadius, sides, rings) glutSolidTorus(innerRadius, outerRadius, sides, rings)
#define gilutWireDodecahedron() glutWireDodecahedron()
#define gilutSolidDodecahedron() glutSolidDodecahedron()
#define gilutWireTeapot(size) glutWireTeapot(size)
#define gilutSolidTeapot(size) glutSolidTeapot(size)
#define gilutWireOctahedron() glutWireOctahedron()
#define gilutSolidOctahedron() glutSolidOctahedron()
#define gilutWireTetrahedron() glutWireTetrahedron()
#define gilutSolidTetrahedron() glutSolidTetrahedron()
#define gilutWireIcosahedron() glutWireIcosahedron()
#define gilutSolidIcosahedron() glutSolidIcosahedron()

#endif // __GILUT_H__


